unit Unit1;

{ game control}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, Buttons,shellApi;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Label1: TLabel;
    Label2: TLabel;
    heightText: TStaticText;
    UpDown1: TUpDown;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    playBtn: TSpeedButton;
    solveBtn: TSpeedButton;
    msglabel: TLabel;
    resetBtn: TSpeedButton;
    GoBtn: TSpeedButton;
    backBtn: TSpeedButton;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Image1: TImage;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure SolveBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure resetBtnClick(Sender: TObject);
    procedure GoBtnClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure backBtnClick(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure PlayBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure GetCPUticks(var CC : int64);

const maxStoneCount = 6;

var
  Form1: TForm1;
  piles : array[1..3,1..maxStoneCount] of byte;
  pheight : array[1..3] of byte;
  stonecount : byte;
  CPUclock : double;

implementation

{$R *.dfm}

uses game_unit;

type TMove = record
              mfrom : byte;   //1..3
              mto   : byte;   //1..3
             end;

const text1 = 'A pile of stones must be moved one by one from pile A to B.';
      text2 = 'A stone may not rest on a  smaller stone.';
      text3 = 'Use the extra pile to avoid this.';
      text4 = 'welcome at the Towers of Hanoi game';
      BGcolor = $f0ffff;
      stoneColor : array[1..maxStoneCount] of dword =
                    ($0000ff,$00ff00,$ff0000,$0080ff,$ff00ff,$ffff00);
      maxmoveNr = 2 shl maxStoneCount;
      maxMoveEntry = 250;
      text5 = 'cannot place stone';
      text6 = 'cannot load stone';
      text7 = 'Press START to solve game';
      text8 = 'Game solved';
      text9 = 'click RESET to close application';
      text10= 'press RESET first...';
      text11= 'how to move?';
      text12= '- type A, B, C   or ...';
      text13= '- click on pile';
      text14= 'waiting for crane';
      text15= 'waiting for reset';
      text16= '';
      text17= '- type X for BACK';

var movelist : array[1..maxmoveNr] of Tmove;
    gamestatus : TGamestatus;
    cranebusy : boolean;
    craneLoaded : Boolean;
    resetFlag : boolean;
    movecount   : byte;
    playMode    : boolean;

procedure clearMovetable;
var i : word;
begin
 movecount := 0;
 for i := 1 to maxmoveNr do
  with movelist[i] do
   begin
    mfrom := 0;
    mto := 0;
   end;
end;

procedure GoReset;
begin
 with form1 do
  begin
   SolveBtn.Enabled := true;
   PlayBtn.Enabled := true;
   resetFlag := false;
   initgame;
   clearmovetable;
   GoBtn.Enabled := not playmode;
   if playMode then
    begin
     msglabel.Caption := text16;
    end
    else
     begin
      msgLabel.Caption := text7;
     end;
  end;
end;

procedure ResetRequest;
//if crane busy post request for reset
begin
 if cranebusy then
  begin
   form1.msglabel.Caption := text15;
   resetflag := true;
  end
  else GoReset;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 craneLoaded := false;
 craneBusy := false;
 playMode := true;
 resetFlag := false;
 stonecount := 6;
 UpDown1.position := stonecount;
 heighttext.Caption := inttostr(stonecount);
 stonecount := UpDown1.position;
 createmap; //--> paint_unit
 GoBtn.Enabled := false;
 initgame;
 label1.Caption := text1;
 label2.caption := text2;
 label3.Caption := text3;
 label5.Caption := text11;
 label6.Caption := text12;
 label7.Caption := text13;
 label10.caption := text17;
 msglabel.caption := text4;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 freemap;
end;

procedure paintedges;
//around paintbox1
var x1,y1,x2,y2 : word;
    i : byte;
begin
 with form1.PaintBox1 do
  begin
   x1 := left-2;
   x2 := left+width+1;
   y1 := top-2;
   y2 := top+height+1;
  end;
 with form1.canvas do
  for i := 0 to 1 do
   begin
    pen.color := 0;
    moveto(x2-i,y1+i);
    lineto(x1+i,y1+i);
    lineto(x1+i,y2-i);
    pen.color := $a00000;
    lineto(x2-i,y2-i);
    lineto(x2-i,y1+i);
   end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 paintedges;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 showGame;//paint_unit;
end;

procedure TForm1.PlayBtnClick(Sender: TObject);
begin
 playMode := true;
 GoBtn.Enabled := false;
 BackBtn.enabled := true;
 msglabel.Caption := text16;
end;

procedure TForm1.SolveBtnClick(Sender: TObject);
begin
 GoBtn.Enabled := true;
 BackBtn.Enabled := false;
 playMode := false;
 msglabel.Caption := text7;
end;

//-- CPU clock

procedure GetCPUticks(var CC : int64);
asm
  mov ECX,cc;
  RDTSC;          //lower 32 bits --> EAX, upper 32 bits ---> EDX
                  //RDTSC = DB $0F,$31
  mov [ECX],EAX;
  add ECX,4;
  mov [ECX],EDX;
end;

procedure setCPUclock;
var T1,T2 : Int64;
    MT1,MT2 : dword;
begin
 MT1 := GetTickCount;
 while MT1 = GetTickCount do;
 GetCPUTicks(T1);
 repeat
  MT2 := GetTickCount;
 until MT2 - MT1 >=  500;
 GetCPUticks(T2);
 CPUclock := (T2 - T1) / (MT2-Mt1);  //clocks per millisec;
end;

procedure reportmove;
//called by recursive search 
begin
 inc(movecount);
 form1.msglabel.Caption := 'move '+inttostr(movecount)+' of '+
                            inttostr((1 shl stonecount)-1);
end;

// crane movement

procedure moveCrane(p : byte);
begin
 if getStatus.cnLoad > 0 then
  begin
   if unloadStone(p) then moveList[movecount].mto := p
    else form1.msglabel.caption := text5;
  end
  else
   if loadStone(p) then
    begin
     if movecount < maxMoveEntry then
      begin
       inc(movecount);
       moveList[movecount].mfrom := p;
       form1.msglabel.caption := 'move '+inttostr(movecount);
      end;
    end
     else form1.msglabel.caption := text6;
end;

procedure moveBack;
begin
 gamestatus := GetStatus;
 if gamestatus.cnLoad > 0 then
  with movelist[movecount] do
   begin
    unloadstone(mfrom);
    mfrom := 0;
    dec(movecount);
    form1.msglabel.caption := 'move '+ inttostr(movecount);
   end
   else
    if movecount > 0 then
     with moveList[movecount] do
      begin
       loadstone(mto);
       unloadstone(mfrom);
       mto := 0;
       mfrom := 0;
       dec(movecount);
       form1.msglabel.Caption := 'move '+ inttostr(movecount);
      end;
end;

procedure solveGame(p1,p2,n : byte);
//move n stones from pile p1 to p2
var p3 : byte;
begin
 if resetFlag then exit;
//
 if (n = 1) then
  begin
   reportmove;
   movestone(p1,p2);        //1 stone to move
  end
  else
   begin
    p3 := p1 xor p2;        //more than 1 stone to move
    solveGame(p1,p3,n-1);
    solveGame(p1,p2,1);
    solveGame(p3,p2,n-1);
   end;
end;

function NewGame : boolean;
begin
 gamestatus := GetStatus;
 with gameStatus do
  result := (pc1 = stonecount) and
            (pc2 = 0) and (pc3 = 0) and (cnLoad = 0);
end;

function SolvedGame : boolean;
begin
 gameStatus := GetStatus;
 with gamestatus do
  result := (pc2 = stonecount);
end;

procedure CheckGameEnd;
var s : string;
    c : byte;
begin
 if SolvedGame then
  begin
   if movecount = (1 shl stonecount)-1 then c := 0 else c := 1;
   s := text8;
   s := s + ' ; score = '+ inttostr(((stonecount-1)*20) shr c);
   s := s + '%';
   form1.msglabel.Caption := s;
  end;
end;

// events

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
var pile : byte;
begin
 if cranebusy then exit;
//
 if playMode then
  begin
   key := UpCase(key);
   cranebusy := true;
   if key in ['A'..'C'] then
    begin
     pile := ord(key) - ord('A') + 1;
     movecrane(pile);
    end;
   if key = 'X' then moveback;
   key := #0;
   cranebusy := false;
  end;
 if resetFlag then GoReset; 
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var p : byte;
 xm250 : word;
begin
 if cranebusy then exit;
//
 if playMode then
  begin
   cranebusy := true;
   resetFlag := false;
   if (x > 40) and (x<750) and (y>115) and (y<785) then
    begin
     x := x - 40;
     xm250 := x mod 250;
     if (xm250 < 210) then
      begin
       p := (x div 250) + 1;
       moveCrane(p);
       checkGameEnd;
      end;
    end;
   cranebusy := false;
  end;
 if resetFlag then GoReset;
end;

procedure TForm1.resetBtnClick(Sender: TObject);
begin
 resetrequest;
end;

procedure TForm1.GoBtnClick(Sender: TObject);
begin
 if newgame then
  begin
   resetFlag := false;
   cranebusy := true;
   GoBtn.Enabled := false;
   playBtn.Enabled := false;
   movecount := 0;
   SolveGame(1,2,stonecount);
   cranebusy := false;
   if resetFlag then GoReset else msglabel.Caption := text8
  end
  else msglabel.caption := text10;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
 ShellExecute(0,'open','http://www.davdata.nl/math', nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.backBtnClick(Sender: TObject);
//take move back
begin
 if cranebusy then exit;
//
 if playMode then
  begin
   cranebusy := true;
   moveBack;
   cranebusy := false;
   if resetFlag then GoReset;
  end;
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
 if newgame then
  begin
   stonecount := UpDown1.Position;
   heighttext.Caption := inttostr(stonecount);
   initgame;
   showgame;
  end
  else begin
        UpDown1.Position := stonecount;
        msglabel.Caption := text10;
       end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if cranebusy then msglabel.Caption := text9;
end;

initialization
 setCPUclock;

end.
