unit paint_unit;

{
 low level paint procedures
 colors are added here
}

interface
{
uses windows,graphics,classes,extCtrls,dialogs;

procedure createmap;
procedure freemap;
procedure showGame;
procedure eraseRect(r : Trect);
procedure paintStoneRect(r : Trect; stoneNr : byte);
procedure paintpoleRect(r : Trect);
procedure eraseGame;
procedure paintcranerail(r : Trect);
procedure paintUpperCrane(Xpos : word);
procedure paintlowercrane(posX,posY,clampX : word; clamp : boolean);
procedure eraseUpperCrane(pos : word);
procedure eraseLowerCrane(posX,posY : word);  ==}

implementation

{==

uses unit1;

const maxheight = 6;
      BGcolor = $f0ffff;
      stoneColor : array[1..maxheight] of dword =
                    ($0000ff,$00ff00,$ff0000,$0080ff,$ff00ff,$ffff00);

var map : Tbitmap;

procedure createmap;
begin
 map := Tbitmap.Create;
 with map do
  begin
   pixelformat := pf32bit;
   width := form1.PaintBox1.Width;
   height := form1.PaintBox1.Height;
  end;
end;

procedure freemap;
begin
 map.Free;
end;

procedure showGame;
begin
 form1.PaintBox1.Canvas.Draw(0,0,map);
end;

procedure paintRect(r : Trect; col : dword);
begin
 with map.Canvas do
  begin
   brush.Color := col;
   brush.style := bsSolid;
   fillrect(r);
  end;
end;

procedure eraseRect(r : Trect);
begin
 paintRect(r,BGcolor);
end;

procedure eraseGame;
var r : Trect;
begin
 with map do r := rect(0,0,width,height);
 paintRect(r,BGcolor);
end;

procedure paintstoneRect(r : Trect; stoneNr : byte);
//paint stone at rectangle r, color col
begin
 with map.Canvas do
  begin
   brush.Color := stonecolor[stoneNr];
   brush.style := bsSolid;
   fillrect(r);
   pen.color := $000000;
   pen.Width := 1;
   moveto(r.left,r.top);
   lineto(r.left,r.bottom-1);
   lineto(r.right-1,r.bottom-1);
   lineto(r.right-1,r.top);
   lineto(r.Left,r.top);
  end;
end;

procedure paintpoleRect(r : Trect);
var i : byte;
begin
 with map.canvas do
  begin
   pen.width := 1;
   for i := 0 to 9 do
    begin
     pen.color := $c0c0c0 - abs(i-5)*$101010;
     moveto(r.left+i,r.top);
     lineto(r.left+i,r.bottom);
    end;
  end;
end;

procedure paintCraneRail(r : Trect);
const railtop = 50;
var i : byte;
    right : word;
begin
 right := map.Width-5;
 with map.canvas do
  begin
   pen.Width := 1;
   for i := 0 to 10 do
    begin
     pen.Color := $00a0d0 - abs(i-5)*$001414;
     moveto(r.Left,r.Top+i);
     lineto(r.Right,r.Top+i);
    end;
  end;
end;

procedure paintcranewheel(pos : word);
var x,y : word;
    angle : single;
begin
 with map.Canvas do
  begin
  angle := 0.045*pos;
  pen.Width := 2;
  pen.color := $000040;
  brush.Color := $0060c0;
  ellipse(pos-23,4,pos+23,50);
  brush.Color := $00ffff;
  pen.color := $c0c0c0;
  pen.Width := 1;
  x := pos + trunc(cos(angle)*15);
  y := 27 + trunc(sin(angle)*15);
  ellipse(x-4,y-4,x+4,y+4);
 end;
end;

procedure paintWheelJoint(pos : word);
//pus chains
var x,y : word;
    i : byte;
begin
 with map.Canvas do
  begin
   pen.Width := 1;
   pen.color := $70;
   brush.Color := $40;
   x := pos-110;
   y := 27;
   for i := 0 to 1 do
    begin
     ellipse(x-10,y-10,x+10,y+10);
     inc(x,220);
    end;
   fillrect(rect(pos-110,y-10,pos+110,y+10));
   pen.color := $ffffff;
   brush.Color := $00ffff;
   x := pos-60;
   for i := 0 to 1 do
    begin
     ellipse(x-3,y-3,x+3,y+3);
     inc(x,120);
    end;
   inc(y,10);
   for i := 0 to 8 do
    begin
     if i and 1 > 0 then pen.color := $c0c0c0 else pen.color := $000000;
     moveto(pos-100+i,y);
     lineto(pos-100+i,50);
     moveto(pos+100+i,y);
     lineto(pos+100+i,50);
    end;
  end;
end;

procedure paintUpperCrane(Xpos : word);
//pos is center of crane
begin
 paintCraneWheel(Xpos-60);
 paintcraneWheel(Xpos+60);
 paintWheelJoint(Xpos); //plus chain
end;

procedure paintlowerCrane(posX,posY,clampX : word; clamp : boolean);
//craneposX,Y hold crane position
var r : Trect;
    x,y : word;
    i : byte;
begin
 r.Left := PosX - 110;
 r.Right := PosX + 110;
 r.Top := 65 + posY;
 r.Bottom := r.Top + 15;
 paintrect(r,$000040);
 with map.Canvas do
  begin
   pen.color := $000040;
   ellipse(r.Left-7,r.Top,r.Left+7,r.Bottom);
   ellipse(r.Right-7,r.Top,r.Right+7,r.Bottom);
   x := posX - clampX;
   y := r.Top + 7;
   pen.color := $000000;
   brush.Color := $000000;
   ellipse(x-7,y-7,x+7,y+7);
   x := posX + clampX;
   ellipse(x-7,y-7,x+7,y+7);
   if clamp = false then         //clamps out
    begin                        //left clamp
     x := posX - clampX - 5;
     y := y -5;
     for i := 0 to 7 do
      begin
       moveto(x-i,y+i);
       lineto(x-i,y+20+i);
      end;
     x := posX-clampX+4;
     y := posY + 78;
     for i := 0 to 8 do
      begin
       moveto(x-i,y-i);
       lineto(x-i,y+i);
      end;
//
     x := posX + clampX + 5;     //right clamp
     y := r.top+2;
     for i := 0 to 7 do
      begin
       moveto(x+i,y+i);
       lineto(x+i,y+20+i);
      end;
     x := posX+clampX-4;
     y := posY + 78;
     for i := 0 to 8 do
      begin
       moveto(x+i,y-i);
       lineto(x+i,y+i);
      end;
    end;//clamp = false
    if clamp then              //clamps engaged
     begin                     //left clamp
      x := posX - clampX - 7;
      for i := 0 to 13 do
       begin
        moveto(x+i,y);
        lineto(x+i,y+12+i);
       end;
      x := posX + clampX - 7;
      for i := 0 to 13 do      //right clamp
       begin
        moveto(x+i,y);
        lineto(x+i,y+25-i);
       end;
     end;//if clamp
    pen.color := $ffffff;
    x := posX-clampx;
    y := 72 + posY;
    ellipse(x-7,y-7,x+7,y+7);
    x := posX + clampX;
    ellipse(x-7,y-7,x+7,y+7);
    y := posY + 65;
    for i := 0 to 8 do         //chain
     begin
      if i and 1 > 0 then pen.color := $c0c0c0 else pen.color := $000000;
      moveto(PosX-100+i,61);
      lineto(PosX-100+i,y);
      moveto(PosX+100+i,61);
      lineto(PosX+100+i,y);
     end;
  end;
end;

procedure eraseUpperCrane(pos : word);
var r : Trect;
begin
 r.left := pos-120;
 r.Right := pos+120;
 r.Top := 0;
 r.Bottom := 50;
 eraseRect(r);
end;

procedure eraseLowerCrane(posX,posY : word);
var r : Trect;
begin
 r.Left := posX - 120;
 r.Right := posX + 120;
 r.top := 61;
 r.Bottom := 115 + posY;
 eraseRect(r);
end;    ==}

end.
